local function AnchorPoint( Class )
	
	local constructor = Class.new --cache
 
	function Class.new()
		
		local instance = constructor() --call default class behavior
		
		
		--chache original functionality
		local __setX = instance.setX
		local __setY = instance.setY
		local __posX = instance.getX
		local __posY = instance.getY
		local __getX = function(self) return Helper:round( __posX(self) ,2 ) end
		local __getY = function(self) return Helper:round( __posY(self) ,2 ) end
		local __setRotation = instance.setRotation
		
		
		local iteration = 0 --counter
		instance.anchorPoint = { --default
			cx = 0,
			cy = 0
		}
		
		
		function instance:getAnchorPointOffsetX()
			return Helper:round( self:getWidth()  * self.anchorPoint.cx ,2 )
		end
		
		function instance:getAnchorPointOffsetY()
			return Helper:round( self:getHeight() * self.anchorPoint.cy ,2 )
		end
		
		
		function instance:setAnchorPoint( cx, cy )
			if  iteration > 0 and (self.anchorPoint.cx and self.anchorPoint.cy ~= 0) then --:setAnchorPoint() called more than ones
				self:setPosition( self:getX() + self:getAnchorPointOffsetX(), self:getY() + self:getAnchorPointOffsetY() )
			end
			
			self.anchorPoint.cx, self.anchorPoint.cy = cx, cy
			
			self:setPosition( __getX(self), __getY(self) ) --refresh
			
			iteration = iteration + 1 --counter
		end
		
		function instance:getAnchorPoint()
			return self.anchorPoint.cx, self.anchorPoint.cy
		end
		
		
		function instance:setX( x )
			__setX( self, x - self:getAnchorPointOffsetX() )
		end
		
		function instance:setY( y )
			__setY( self, y - self:getAnchorPointOffsetY() )
		end
		
		
		function instance:getX()
			return __getX(self) + self:getAnchorPointOffsetX()
		end
		
		function instance:getY()
			return __getY(self) + self:getAnchorPointOffsetY()
		end
		
		
		function instance:setPosition( x, y )
			self:setX(x)
			self:setY(y)
		end
		
		function instance:getPosition()
			return self:getX(), self:getY()
		end
		
		
		function instance:setRotation( n )
			local cx, cy = self:getAnchorPoint()
			
			self:setAnchorPoint(0,0)
			
			__setRotation(self, n)
			
			self:setAnchorPoint(cx, cy)
		end
		
		
		return instance
		
	end
	
end


--apply to classes
AnchorPoint( Sprite )
AnchorPoint( Shape  )